package com.jsliders.puble;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

import android.app.AlertDialog;
import android.content.Context;
import android.database.Cursor;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.Toast;

public class Maps extends MapActivity implements LocationListener {

	protected static final int UPDATE_LOCATION = 0;
	protected static final String TAG = null;
	private LocationManager mLocationManager;
	//Keskusta
	private double mLongitude = 61.058638; 
	private double mLatitude = 28.189223;
	//Sammonlahti
//	private double mLongitude = 61.051203;
//	private double mLatitude = 28.105989;
//	private double mLongitude = 0;
//	private double mLatitude = 0;
	private MapController mapcontroller;
	private MapView mapview;
	List<Overlay> mapOverlays;
	TableRestaurant tr;
	
	
	/**
	 * Creates menu items from a resource file.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
	    MenuInflater inflater = getMenuInflater();
	    inflater.inflate(R.menu.mapsmenu, menu);
	    return true;
	}
	/**
	 * Handles the creation of a new marker on the map.
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
	        case R.id.my_location:
	    	    mapcontroller.animateTo(setMyLocation());
	    	    mapcontroller.setZoom(15);
	          return true;
	        case R.id.restaurants:
	        	drawPlaces(3);
	        	return true;
	        case R.id.pub:
	        	drawPlaces(1);
	        	return true;
	        case R.id.nightclub:
	        	drawPlaces(2);
	        	return true;
	    }
	    return super.onOptionsItemSelected(item);
	}
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
	    setContentView(R.layout.map);
	    
	    mapview = (MapView)findViewById(R.id.mapview);
	    mapcontroller = mapview.getController();
	    mapview.setBuiltInZoomControls(true);
	    tr = new TableRestaurant(this);
	    
//	       //---use the LocationManager class to obtain GPS locations---
//	    mLocationManager = (LocationManager) 
//            getSystemService(Context.LOCATION_SERVICE);    
//        
//	    mLocationManager.requestLocationUpdates(
//            LocationManager.GPS_PROVIDER, 
//            0, 
//            0, 
//            this);
	}

	public GeoPoint setMyLocation() {
		mapOverlays = mapview.getOverlays();
		Drawable drawable = getResources().getDrawable(R.drawable.me);
	    MapItemizedOverlay itemizedoverlay = new MapItemizedOverlay(drawable,this);
	   
	    GeoPoint point = new GeoPoint((int)(mLongitude * 1E6), (int)(mLatitude * 1E6));
	    OverlayItem overlayitem = new OverlayItem(point,"Me","Dont open Intent");
	    itemizedoverlay.addOverlay(overlayitem);
	    mapOverlays.add(itemizedoverlay);
	    return point;
	}
	
	public void drawPlaces(int restType) {
		Cursor c = tr.queryAll(tr.KEY_RESTAURANTTYPE+"="+restType, null, null, null, null);
		
		if (c.getCount() > 0) {
			do 
			{
				drawPlaceWithAddress(c.getString(c.getColumnIndex(tr.KEY_ADDRESS)) + " " + c.getString(c.getColumnIndex(tr.KEY_CITY)),c.getInt(c.getColumnIndex(tr.KEY_ROWID)),restType);
			} while(c.moveToNext());
			mapview.invalidate();
		}
	}
	
	public void drawPlaceWithAddress(String address,int id,int restType){
		  Geocoder geoCoder = new Geocoder(this, Locale.getDefault());    
	        try {
	            List<Address> addresses = geoCoder.getFromLocationName(
	                address, 5);
	            if (addresses.size() > 0) {
	                GeoPoint p = new GeoPoint(
	                        (int) (addresses.get(0).getLatitude() * 1E6), 
	                        (int) (addresses.get(0).getLongitude() * 1E6));
	                mapOverlays = mapview.getOverlays();
	                if(getDistanceMeAndPoint(p) < 1)
	                {
		                Drawable drawable=null;
		                switch (restType) {
		                	case 1:
		                		drawable = getResources().getDrawable(R.drawable.androidmarker);
		                		break;
		                	case 2:
		                		drawable = getResources().getDrawable(R.drawable.androidmarker2);
		                		break;
		                	case 3:
		                		drawable = getResources().getDrawable(R.drawable.notesicon);
		                		break;
		                }
		        	    MapItemizedOverlay itemizedoverlay = new MapItemizedOverlay(drawable,this);
		        	    OverlayItem overlayitem = new OverlayItem(p,""+id,address);
		        	    itemizedoverlay.addOverlay(overlayitem);
		        	    mapOverlays.add(itemizedoverlay);
	                }
	            }    
	        } catch (IOException e) {
	            e.printStackTrace();
	        }
	}
	public double getDistanceMeAndPoint(GeoPoint point) {
		GeoPoint myPoint = new GeoPoint((int)(mLongitude * 1E6), (int)(mLatitude * 1E6));
		return CalculationByDistance(myPoint, point);
	}
    public double CalculationByDistance(GeoPoint StartP, GeoPoint EndP) {
        double lat1 = StartP.getLatitudeE6()/1E6;
        double lat2 = EndP.getLatitudeE6()/1E6;
        double lon1 = StartP.getLongitudeE6()/1E6;
        double lon2 = EndP.getLongitudeE6()/1E6;
        double dLat = Math.toRadians(lat2-lat1);
        double dLon = Math.toRadians(lon2-lon1);
        double a = Math.sin(dLat/2) * Math.sin(dLat/2) +
        Math.cos(Math.toRadians(lat1)) * Math.cos(Math.toRadians(lat2)) *
        Math.sin(dLon/2) * Math.sin(dLon/2);
        double c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
        return 6371 * c;
    }
	/**
	 * Invoked by the location service when phone's location changes.
	 */
	 public void onLocationChanged(Location newLocation) {
		setCurrentGpsLocation(newLocation);  	
	 }
	/**
	 * Resets the GPS location whenever the provider is enabled.
	 */
	 public void onProviderEnabled(String provider) {
		setCurrentGpsLocation(null);  	
	 }
	/**
	 * Resets the GPS location whenever the provider is disabled.
	 */
	 public void onProviderDisabled(String provider) {
		setCurrentGpsLocation(null);  	
	 }
	/**
	 * Resets the GPS location whenever the provider status changes. We
	 * don't care about the details.
	 */
	 public void onStatusChanged(String provider, int status, Bundle extras) {
		setCurrentGpsLocation(null);  	
	 }
	/**
	 * Sends a message to the update handler with either the current location or 
	 *  the last known location. 
	 * @param location is either null or the current location
	 */
	 private void setCurrentGpsLocation(Location location) {
//		if (location == null) {
//			mLocationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
//	                mLocationManager.requestLocationUpdates(
//			    LocationManager.GPS_PROVIDER, 30000, 0, this); // Every 30000 msecs	
//			location = mLocationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);				
//		}
//		try {
//			mLongitude = location.getLongitude();
//			mLatitude = location.getLatitude();
////			Log.i(TAG, "<long,lat> = <" + mLongitude + "," + mLatitude);
//			Message msg = Message.obtain();
//			msg.what = UPDATE_LOCATION;
//		} catch (NullPointerException e) {
////			Log.i(TAG, "Null pointer exception " + mLongitude + "," + mLatitude);
//		}
		 if (location != null) {
             Toast.makeText(getBaseContext(), 
                     "Location changed : Lat: " + location.getLatitude() + 
                     " Lng: " + location.getLongitude(), 
                     Toast.LENGTH_SHORT).show();
			 mLongitude = location.getLongitude();
			 mLatitude = location.getLatitude();
		 }
	 }
}
