package com.jsliders.puble;

import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;

public class OfferList extends ListActivity {
    TableOffers offers;
    TableRestaurant tr;
    
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.restaurant_list);
        offers = new TableOffers(this);
        tr = new TableRestaurant(this);
        fillData();
    }
	
    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) {
    	int rid;
    	super.onListItemClick(l, v, position, id);
    	Cursor c = offers.queryAll(offers.KEY_ROWID+"="+id, null, null, null, null);
    	
    	if (c.getCount() > 0) {
    		rid = c.getInt(c.getColumnIndex(offers.KEY_RID));
        	Intent intent = new Intent(getApplicationContext(),Restaurant.class);
        	intent.putExtra("RID", Integer.parseInt(""+rid));
        	startActivity(intent);
    	}
    }
    
    private void fillData() {
    	Bundle b = this.getIntent().getExtras();
        String city = null;
        String ids = "";
        
    	if(b.getString("City") != null){
        	city = "City LIKE \"%" + (b.getString("City")) + "%\"";
        	Cursor cRest = tr.queryAll(city, null, null, null, null);
        	
        	if (cRest.getCount() > 0 ) {
        		do {
        			ids += cRest.getString(cRest.getColumnIndex(tr.KEY_ROWID)) + ",";
        		} while (cRest.moveToNext());
        		//ids = cRest.getString(0);
        		ids = ids.substring(0, ids.length()-1);
        	}
        }
    	
    	// Get all of the notes from the database and create the item list
        Cursor c = offers.queryAll(offers.KEY_RID + " IN (" +ids + ")", null, null, null, null);
        startManagingCursor(c);

        String[] from = new String[] { offers.KEY_STARTTIME,offers.KEY_ENDTIME,offers.KEY_DESCRIPTION };
        int[] to = new int[] { R.id.TextStart,R.id.TextEnd,R.id.TextDescription };
        
        // Now create an array adapter and set it to display using our row
        SimpleCursorAdapter notes =
            new SimpleCursorAdapter(this, R.layout.offer_list_item, c, from, to);
        setListAdapter(notes);
        
    }
    @Override
    protected void onResume() {
        super.onResume();
        fillData();
    }
}
