package com.jsliders.puble;

import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;

public class RestaurantList extends ListActivity {
    TableRestaurant tr;
    boolean fromQuery = false;
    
    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) {
    	// TODO Auto-generated method stub
    	super.onListItemClick(l, v, position, id);
    	
    	Intent intent;
    	if (fromQuery == true)
    	{
    		intent = new Intent(getApplicationContext(),Restaurant.class);
    		
    	} else {
    		intent = new Intent(getApplicationContext(),Clicker.class);
    	}
    	
    	intent.putExtra("RID", Integer.parseInt(""+id));
    	startActivity(intent);
    }
    
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.restaurant_list);
        //mDbHelper = new NotesDbAdapter(this);
        tr = new TableRestaurant(this);
        fillData();
    }
	
    private void fillData() {
    	Bundle b = this.getIntent().getExtras();
        String city = null;
        
        if (b.getBoolean("Clicker")== false) {
	    	if(b.getString("City") != null){
	        	city = "City LIKE \"%" + (b.getString("City")) + "%\"";
	        	fromQuery = true;
	        }
        }
    	
    	// Get all of the notes from the database and create the item list
        Cursor c = tr.queryAll(city, null, null, null, null);
        startManagingCursor(c);

        String[] from = new String[] { tr.KEY_NAME,tr.KEY_ADDRESS,tr.KEY_CITY };
        int[] to = new int[] { R.id.TextName,R.id.TextAddress,R.id.TextCity };
        
        // Now create an array adapter and set it to display using our row
        SimpleCursorAdapter notes =
            new SimpleCursorAdapter(this, R.layout.restaurant_list_item, c, from, to);
        setListAdapter(notes);
        
    }
    @Override
    protected void onResume() {
        super.onResume();
        fillData();
    }
}
