package com.jsliders.puble;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;

public class TableCustomercount {
    public static final String KEY_ROWID = "_id";
    public static final String KEY_RID = "rid";
    public static final String KEY_COUNTER = "Counter";
    public static final String KEY_DIRECTION = "Direction";
    public static final String KEY_DATE = "Date";
    public static final String KEY_TIME = "Time";
    
    private static final String DATABASE_TABLE = "customercount";
    
    private PubleDatabaseProvider db;
    
    public TableCustomercount(Context ctx){
    	db = new PubleDatabaseProvider(ctx);
    }
    
    //---insert a restaurant into the database---
    public long insert(int rid, int counter, int direction, String date, String time) 
    {
    	
        ContentValues initialValues = new ContentValues();
        initialValues.put(KEY_RID, rid);
        initialValues.put(KEY_COUNTER, counter);
        initialValues.put(KEY_DIRECTION, direction);
        initialValues.put(KEY_DATE, date);
        initialValues.put(KEY_TIME, time);

        
        return db.insert(DATABASE_TABLE, initialValues);
    }
    
    //---deletes a particular title---
    public boolean delete(long rowId) 
    {
        return db.delete(DATABASE_TABLE, KEY_ROWID + 
        		"=" + rowId);
    }
    
    
    public Cursor rawQuery(String sql, String[] selectionArgs){
    	return db.rawQuery(sql, selectionArgs);
    }
    
    public Cursor queryAll(String selection, 
    		String[] selectionArgs, String groupBy, String having, String orderBy)
    {
    	return db.query(DATABASE_TABLE, new String[] {KEY_ROWID, 
    			KEY_RID, KEY_COUNTER, KEY_DIRECTION, KEY_DATE, KEY_TIME}, 
    			selection, selectionArgs, groupBy, having, orderBy);
    
    }
}
