package com.jsliders.puble;


import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;

public class TableMenu {
	public static final String KEY_ROWID = "_id";
    public static final String KEY_RID = "rid";
    public static final String KEY_NAME = "Name";
    public static final String KEY_DESCRIPTION = "Description";
    public static final String KEY_PRICE = "Price";

    
    private static final String DATABASE_TABLE = "menu";
    
    private PubleDatabaseProvider db;
    
    public TableMenu(Context ctx){
    	db = new PubleDatabaseProvider(ctx);
    }
    
  //---insert a restaurant into the database---
    public long insert(int rid, String name, String description, double price) 
    {
        ContentValues initialValues = new ContentValues();
        initialValues.put(KEY_RID, rid);
        initialValues.put(KEY_NAME, name);
        initialValues.put(KEY_DESCRIPTION, description);
        initialValues.put(KEY_PRICE, price);

        return db.insert(DATABASE_TABLE, initialValues);
    }
    
  //---deletes a particular title---
    public boolean delete(long rowId) 
    {
        return db.delete(DATABASE_TABLE, KEY_ROWID + 
        		"=" + rowId);
    }
    
    
    public Cursor rawQuery(String sql, String[] selectionArgs){
    	return db.rawQuery(sql, selectionArgs);
    }
    
    public Cursor queryAll(String selection, 
    		String[] selectionArgs, String groupBy, String having, String orderBy)
    {
    	return db.query(DATABASE_TABLE, new String[] {KEY_ROWID, 
    			KEY_RID, KEY_NAME, KEY_DESCRIPTION, KEY_PRICE}, 
    			selection, selectionArgs, groupBy, having, orderBy);
    
    }
}
