package com.jsliders.puble;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;

public class TableOffers {

    public static final String KEY_ROWID = "_id";
    public static final String KEY_RID = "rid";
    public static final String KEY_DESCRIPTION = "Description";
    public static final String KEY_STARTTIME = "StartTime";
    public static final String KEY_ENDTIME = "EndTime";
    private static final String DATABASE_TABLE = "offers";
    
    private PubleDatabaseProvider db;
    
    public TableOffers(Context ctx){
    	db = new PubleDatabaseProvider(ctx);
    }
    
    //---insert a restaurant into the database---
    public long insert(int rid, String description,String starttime,String endtime) 
    {
    	
        ContentValues initialValues = new ContentValues();
        initialValues.put(KEY_RID, rid);
        initialValues.put(KEY_DESCRIPTION, description);
        initialValues.put(KEY_STARTTIME, starttime);
        initialValues.put(KEY_ENDTIME, endtime);
        
        return db.insert(DATABASE_TABLE, initialValues);
    }
    
    //---deletes a particular title---
    public boolean delete(long rowId) 
    {
        return db.delete(DATABASE_TABLE, KEY_ROWID + 
        		"=" + rowId);
    }
    
    
    public Cursor rawQuery(String sql, String[] selectionArgs){
    	return db.rawQuery(sql, selectionArgs);
    }
    
    public Cursor queryAll(String selection, 
    		String[] selectionArgs, String groupBy, String having, String orderBy)
    {
    	return db.query(DATABASE_TABLE, new String[] {KEY_ROWID, 
    			KEY_RID, KEY_DESCRIPTION,KEY_STARTTIME,KEY_ENDTIME}, 
    			selection, selectionArgs, groupBy, having, orderBy);
    
    }

}
