package com.jsliders.puble;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;

public class TableProgramme {
	public static final String KEY_ROWID = "_id";
    public static final String KEY_RID = "Rid";
    public static final String KEY_DATE = "Date";
    public static final String KEY_SHOWTIME = "Showtime";
    public static final String KEY_COST = "Cost";
    public static final String KEY_DESCRIPTION = "Description";
    
    private static final String DATABASE_TABLE = "programme";
    
    private PubleDatabaseProvider db;
    
    public TableProgramme(Context ctx){
    	db = new PubleDatabaseProvider(ctx);
    }
    
    //---insert a restaurant into the database---
    public long insert(int rid, String date, String showtime, int cost, String description) 
    {
    	
        ContentValues initialValues = new ContentValues();
        initialValues.put(KEY_RID, rid);
        initialValues.put(KEY_DATE, date);
        initialValues.put(KEY_SHOWTIME, showtime);
        initialValues.put(KEY_COST, cost);
        initialValues.put(KEY_DESCRIPTION, description);
        
        return db.insert(DATABASE_TABLE, initialValues);
    }
    
    //---deletes a particular title---
    public boolean delete(long rowId) 
    {
        return db.delete(DATABASE_TABLE, KEY_ROWID + 
        		"=" + rowId);
    }
    
    
    public Cursor rawQuery(String sql, String[] selectionArgs){
    	return db.rawQuery(sql, selectionArgs);
    }
    
    public Cursor queryAll(String selection, 
    		String[] selectionArgs, String groupBy, String having, String orderBy)
    {
    	return db.query(DATABASE_TABLE, new String[] {KEY_ROWID, 
    			KEY_RID, KEY_DATE, KEY_SHOWTIME, KEY_COST, KEY_DESCRIPTION}, 
    			selection, selectionArgs, groupBy, having, orderBy);
    
    }
}