package com.jsliders.puble;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;

public class TableRestaurant {

    public static final String KEY_ROWID = "_id";
    public static final String KEY_NAME = "Name";
    public static final String KEY_ADDRESS = "Address";
    public static final String KEY_POSTALCODE = "Postalcode";
    public static final String KEY_CITY = "City";
    public static final String KEY_PHONE = "Phone";
    public static final String KEY_EMAIL = "Email";
    public static final String KEY_MAXCUSTOMERS = "MaxCustomers";
    public static final String KEY_OPENHOURS = "Openhours";
    public static final String KEY_RESTAURANTTYPE = "RestaurantType";
    
    private static final String DATABASE_TABLE = "restaurant";
    
    private PubleDatabaseProvider db;
    
    public TableRestaurant(Context ctx){
    	db = new PubleDatabaseProvider(ctx);
    }
    
    //---insert a restaurant into the database---
    public long insert(String name, String address, String city, String phone, 
    		String email, int maxCustomers,String openHours,String restaurantType) 
    {
    	
        ContentValues initialValues = new ContentValues();
        initialValues.put(KEY_NAME, name);
        initialValues.put(KEY_ADDRESS, address);
        initialValues.put(KEY_CITY, city);
        initialValues.put(KEY_PHONE, phone);
        initialValues.put(KEY_EMAIL, email);
        initialValues.put(KEY_MAXCUSTOMERS, maxCustomers);
        initialValues.put(KEY_OPENHOURS, openHours);
        initialValues.put(KEY_RESTAURANTTYPE, restaurantType);
        
        return db.insert(DATABASE_TABLE, initialValues);
    }
    
    //---deletes a particular title---
    public boolean delete(long rowId) 
    {
        return db.delete(DATABASE_TABLE, KEY_ROWID + 
        		"=" + rowId);
    }
    
    
    public Cursor rawQuery(String sql, String[] selectionArgs){
    	return db.rawQuery(sql, selectionArgs);
    }
    
    public Cursor queryAll(String selection, 
    		String[] selectionArgs, String groupBy, String having, String orderBy)
    {
    	return db.query(DATABASE_TABLE, new String[] {KEY_ROWID, 
    			KEY_NAME, KEY_ADDRESS,KEY_POSTALCODE, KEY_CITY, KEY_PHONE, KEY_EMAIL, KEY_MAXCUSTOMERS,KEY_OPENHOURS}, 
    			selection, selectionArgs, groupBy, having, orderBy);
    
    }

}
